VST 3 Examples: Plug Class Reference
Author: Steinberg

VST 3 Examples VST 3.8 SDK for developing VST plug-in

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Attributes | List of all members
Plug Class Reference

`#include <plug.h>`

Inheritance diagram for Plug:

## Public Member Functions
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | sendTextMessage (const char16 *text)
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | getPrefetchableSupport (PrefetchableSupport &prefetchable) SMTG_OVERRIDE
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
Public Member Functions inherited from AudioEffect
| AudioEffect ()
AudioBus * | addAudioInput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | addAudioOutput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | getAudioInput (int32 index)
AudioBus * | getAudioOutput (int32 index)
EventBus * | addEventInput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | addEventOutput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | getEventInput (int32 index)
EventBus * | getEventOutput (int32 index)
tresult | setBusArrangements (SpeakerArrangement *inputs, int32 numIns, SpeakerArrangement *outputs, int32 numOuts) SMTG_OVERRIDE
tresult | getBusArrangement (BusDirection dir, int32 busIndex, SpeakerArrangement &arr) SMTG_OVERRIDE
tresult | canProcessSampleSize (int32 symbolicSampleSize) SMTG_OVERRIDE
uint32 | getLatencySamples () SMTG_OVERRIDE
tresult | setupProcessing (ProcessSetup &setup) SMTG_OVERRIDE
tresult | setProcessing (TBool state) SMTG_OVERRIDE
uint32 | getTailSamples () SMTG_OVERRIDE
uint32 | getProcessContextRequirements () SMTG_OVERRIDE
Public Member Functions inherited from Component
| Component ()
void | setControllerClass (const FUID &cid)
void | setControllerClass (const TUID &cid)
tresult | removeAudioBusses ()
tresult | removeEventBusses ()
tresult | renameBus (MediaType type, BusDirection dir, int32 index, const String128 newName)
tresult | getControllerClassId (TUID classID) SMTG_OVERRIDE
tresult | setIoMode (IoMode mode) SMTG_OVERRIDE
int32 | getBusCount (MediaType type, BusDirection dir) SMTG_OVERRIDE
tresult | getBusInfo (MediaType type, BusDirection dir, int32 index, BusInfo &info) SMTG_OVERRIDE
tresult | getRoutingInfo (RoutingInfo &inInfo, RoutingInfo &outInfo) SMTG_OVERRIDE
tresult | activateBus (MediaType type, BusDirection dir, int32 index, TBool state) SMTG_OVERRIDE
tresult | setActive (TBool state) SMTG_OVERRIDE
tresult | terminate () SMTG_OVERRIDE
BusList * | getBusList (MediaType type, BusDirection dir)
tresult | removeAllBusses ()
Public Member Functions inherited from ComponentBase
| ComponentBase ()
| ~ComponentBase () override
FUnknown * | getHostContext () const
IConnectionPoint * | getPeer () const
IMessage * | allocateMessage () const
tresult | sendMessage (IMessage *message) const
tresult | sendTextMessage (const char8 *text) const
tresult | sendMessageID (const char8 *messageID) const
virtual tresult | receiveText (const char8 *text)
tresult | terminate () SMTG_OVERRIDE
tresult | connect (IConnectionPoint *other) SMTG_OVERRIDE
tresult | disconnect (IConnectionPoint *other) SMTG_OVERRIDE
tresult | notify (IMessage *message) SMTG_OVERRIDE
Public Member Functions inherited from FUnknown
virtual tresult | queryInterface (const TUID _iid, void **obj)=0
virtual uint32 | addRef ()=0
virtual uint32 | release ()=0

## Static Public Member Functions
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)

## Public Attributes
OBJ_METHODS(Plug, AudioEffect) DEFINE_INTERFACES DEF_INTERFACE(Vst bool | bBypass
Public Attributes inherited from AudioEffect
OBJ_METHODS(AudioEffect, Component) DEFINE_INTERFACES DEF_INTERFACE(IAudioProcessor) DEF_INTERFACE(IProcessContextRequirements) END_DEFINE_INTERFACES(Component) REFCOUNT_METHODS(Component) protected ProcessContextRequirements | processContextRequirements
Public Attributes inherited from Component
OBJ_METHODS(Component, ComponentBase) DEFINE_INTERFACES DEF_INTERFACE(IComponent) END_DEFINE_INTERFACES(ComponentBase) REFCOUNT_METHODS(ComponentBase) protected BusList | audioInputs
BusList | audioOutputs
BusList | eventInputs
BusList | eventOutputs
Public Attributes inherited from ComponentBase
OBJ_METHODS(ComponentBase, FObject) DEFINE_INTERFACES DEF_INTERFACE(IPluginBase) DEF_INTERFACE(IConnectionPoint) END_DEFINE_INTERFACES(FObject) REFCOUNT_METHODS(FObject) protected IPtr< IConnectionPoint > | peerConnection
Public Attributes inherited from IProcessContextRequirements
| kNeedSystemTime
| kNeedContinousTimeSamples
| kNeedProjectTimeMusic
| kNeedBarPositionMusic
| kNeedCycleMusic
| kNeedSamplesToNextClock
| kNeedTempo
| kNeedTimeSignature
| kNeedChord
| kNeedFrameRate
| kNeedTransportState

## Protected Attributes
bool | bBypass { false }
int32 | mCurrentProgram [kNumSlots] {0}
float | mCurrentGainValue {0.f}
uint32 | mProgramCount {128}
int32 | mLastNoteOnId
int32 | mLastNoteOnPitch
int32 | currentProgram
float | currentGainValue

## Additional Inherited Members
Public Types inherited from IProcessContextRequirements
enum | Flags
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid
Static Public Attributes inherited from IConnectionPoint
static const FUID | iid
Static Public Attributes inherited from IComponent
static const FUID | iid
Static Public Attributes inherited from IAudioProcessor
static const FUID | iid
Static Public Attributes inherited from IProcessContextRequirements
static const FUID | iid
Static Public Attributes inherited from IPrefetchableSupport
static const FUID | iid

## Constructor & Destructor Documentation

## ◆ Plug() [1/5]

Plug | ( |  | ) |

## ◆ Plug() [2/5]

Plug | ( |  | ) |

## ◆ Plug() [3/5]

Plug | ( |  | ) |

## ◆ Plug() [4/5]

Plug | ( |  | ) |

## ◆ Plug() [5/5]

Plug | ( |  | ) |

## Member Function Documentation

## ◆ createInstance() [1/5]

static FUnknown * createInstance | ( | void * |  | ) |
| inlinestatic

## ◆ initialize() [1/5]

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from Component.

## ◆ process() [1/5]

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

## ◆ setState() [1/5]

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from Component.

## ◆ getState() [1/5]

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from Component.

## ◆ createInstance() [2/5]

static FUnknown * createInstance | ( | void * |  | ) |
| inlinestatic

## ◆ initialize() [2/5]

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from Component.

## ◆ process() [2/5]

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

## ◆ setState() [2/5]

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from Component.

## ◆ getState() [2/5]

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from Component.

## ◆ createInstance() [3/5]

static FUnknown * createInstance | ( | void * |  | ) |
| inlinestatic

## ◆ initialize() [3/5]

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from Component.

## ◆ process() [3/5]

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

## ◆ setState() [3/5]

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from Component.

## ◆ getState() [3/5]

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from Component.

## ◆ sendTextMessage()

tresult sendTextMessage | ( | const char16 * | text | ) |

## ◆ createInstance() [4/5]

static FUnknown * createInstance | ( | void * |  | ) |
| inlinestatic

## ◆ initialize() [4/5]

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from Component.

## ◆ process() [4/5]

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

## ◆ setState() [4/5]

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from Component.

## ◆ getState() [4/5]

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from Component.

## ◆ getPrefetchableSupport()

tresult getPrefetchableSupport | ( | PrefetchableSupport & | prefetchable | ) |
| virtual

Implements IPrefetchableSupport.

## ◆ createInstance() [5/5]

static FUnknown * createInstance | ( | void * |  | ) |
| inlinestatic

## ◆ initialize() [5/5]

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from Component.

## ◆ process() [5/5]

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

## ◆ setState() [5/5]

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from Component.

## ◆ getState() [5/5]

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from Component.

## Member Data Documentation

## ◆ bBypass [1/2]

bool bBypass { false }
| protected

## ◆ mCurrentProgram

int32 mCurrentProgram[kNumSlots] {0}
| protected

## ◆ mCurrentGainValue

float mCurrentGainValue {0.f}
| protected

## ◆ mProgramCount

uint32 mProgramCount {128}
| protected

## ◆ mLastNoteOnId

int32 mLastNoteOnId
| protected

## ◆ mLastNoteOnPitch

int32 mLastNoteOnPitch
| protected

## ◆ bBypass [2/2]

OBJ_METHODS (Plug, AudioEffect) DEFINE_INTERFACES DEF_INTERFACE (Vst bool bBypass

## ◆ currentProgram

int32 currentProgram
| protected

## ◆ currentGainValue

float currentGainValue
| protected

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.